package schedframe.resources.computing.profiles.load;

import java.util.LinkedList;

import org.joda.time.DateTimeUtilsExt;

import schemas.LoadCalendar;
import schemas.LoadDistribution;
import schemas.LoadSchedule;


public class ResourceLoadCalendar {
	
	//private Day[] week;
	private LinkedList<TimestampUtilization> loadDistribution;
	
	public ResourceLoadCalendar(LoadCalendar loadCalendar){
		/*week = new Day[7];
		for(int i = 0; i < 7; i++){
			week[i] = new Day();
		}*/
		
		loadDistribution = new LinkedList<TimestampUtilization>();
		
		for(int i = 0; i < loadCalendar.getLoadScheduleCount(); i++){
			LoadSchedule loadSched = loadCalendar.getLoadSchedule(i);
			for(int j = 0; j < loadSched.getLoadDistributionCount(); j++){
				LoadDistribution ld = loadSched.getLoadDistribution(j);
				TimestampUtilization tu = new TimestampUtilization(ld.getFromTime(), ld.getToTime(), ld.getLoadLevel());
				loadDistribution.add(tu);
			}
		}
		
		/*for(int i = 0; i < loadCalendar.getWeekDayCount(); i++){
			WeekDay weekDay = loadCalendar.getWeekDay(i);
			if(weekDay.getType().equals(DayType.VALUE_0)){
				WeekDayTypeChoice wdc = weekDay.getWeekDayTypeChoice();
				for(int j = 0; j < 7; j++){
					if(wdc.hasLoadLevel()){
						TimeUtilization tu = new TimeUtilization (new LocalTime(0, 0), new LocalTime(23, 59), wdc.getLoadLevel());
						week[j].add(tu);
					} else {
						for(int k = 0; k < wdc.getTimePeriodCount(); k++){
							TimePeriod tp = wdc.getTimePeriod(k);
							TimeUtilization tu = new TimeUtilization (new LocalTime(tp.getFromTime().getHour(), tp.getFromTime().getMinute()), new LocalTime(tp.getToTime().getHour(), tp.getToTime().getMinute()), tp.getLoadLevel());
							week[j].add(tu);
						}
					}
				}
			} else {
				WeekDayTypeChoice wdc = weekDay.getWeekDayTypeChoice();
				if(wdc.hasLoadLevel()){
					TimeUtilization tu = new TimeUtilization (new LocalTime(0, 0), new LocalTime(23, 59), wdc.getLoadLevel());
					week[weekDay.getType().ordinal() - 1].add(tu);
				} else {
					for(int k = 0; k < wdc.getTimePeriodCount(); k++){
						TimePeriod tp = wdc.getTimePeriod(k);
						TimeUtilization tu = new TimeUtilization (new LocalTime(tp.getFromTime().getHour(), tp.getFromTime().getMinute()), new LocalTime(tp.getToTime().getHour(), tp.getToTime().getMinute()), tp.getLoadLevel());
						week[weekDay.getType().ordinal() - 1].add(tu);
					}
				}
			}	
		}*/
	}
	
	public ResourceLoadCalendar(){
		loadDistribution = new LinkedList<TimestampUtilization>();
	}
	
	/*public double getLoad(DateTime dateTime){
		int dayType = dateTime.getDayOfWeek();
		int timeOfDay = dateTime.getMillisOfDay();
		Day day = week[dayType];
		for(TimeUtilization tu: day){
			if(tu.getStartTime().getMillisOfDay() <= timeOfDay && tu.getEndTime().getMillisOfDay() > timeOfDay)
				return tu.getUtlization();
		}
		return 0;
	}*/
	
	public double getCurrentLoad(){
		long simStartTime = DateTimeUtilsExt.getOffsetTime().getTimeInMillis();
		long currentTime = DateTimeUtilsExt.currentTimeMillis();
		long runTime = (currentTime-simStartTime) / 1000;

		for(int i = 0; i < loadDistribution.size(); i++){
			TimestampUtilization tu = loadDistribution.get(i);
			if(tu.getStartTime() == runTime) {
				return loadDistribution.get(i).getUtlization();
			} else if(tu.getStartTime() > runTime && i != 0) {
				return loadDistribution.get(i-1).getUtlization();
			}
		}
		return 0;
	}

	public void setLoadDistribution(LinkedList<TimestampUtilization> loadDistribution) {
		this.loadDistribution = loadDistribution;
	}
	public LinkedList<TimestampUtilization> getLoadDistribution() {
		return loadDistribution;
	}
}

/*class Day extends ArrayList<TimeUtilization> {

	private static final long serialVersionUID = -1788266677275361001L;
}

class TimeUtilization implements Comparable<TimeUtilization>{

	LocalTime startTime;
	LocalTime endTime;
	double utlization;

	TimeUtilization(LocalTime startTime, LocalTime endTime, double utlization) {
		super();
		this.startTime = startTime;
		this.endTime = endTime;
		this.utlization = utlization;
	}

	public double getUtlization() {
		return utlization;
	}
	public void setUtlization(double utlization) {
		this.utlization = utlization;
	}

	@Override
	public int compareTo(TimeUtilization arg0) {
		if(this.getStartTime().getMillisOfDay() < arg0.getStartTime().getMillisOfDay() )
			return 1;
		else if (this.getStartTime().getMillisOfDay() > arg0.getStartTime().getMillisOfDay() )
			return -1;
		else 
			return 0;
	}
	public LocalTime getStartTime() {
		return startTime;
	}
	public void setStartTime(LocalTime startTime) {
		this.startTime = startTime;
	}
	public LocalTime getEndTime() {
		return endTime;
	}
	public void setEndTime(LocalTime endTime) {
		this.endTime = endTime;
	}
}
*/

